From 8f4bb718b51750da7f4a8c3537939252912488dc Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 9 Jul 2025 05:21:46 +0300
Subject: [PATCH 86/86] stub ruleset: Replace tabs with spaces

See RM #1595

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/stub/buildings.ruleset | 32 ++++++++++++++++----------------
 data/stub/effects.ruleset   |  4 ++--
 data/stub/game.ruleset      | 12 ++++++------
 data/stub/nations.ruleset   |  6 +++---
 4 files changed, 27 insertions(+), 27 deletions(-)

diff --git a/data/stub/buildings.ruleset b/data/stub/buildings.ruleset
index 081176a73a..3f0199fce8 100644
--- a/data/stub/buildings.ruleset
+++ b/data/stub/buildings.ruleset
@@ -35,18 +35,18 @@ format_version = 50
 ;                 the name used in savegames must not change, if you want
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
-; genus	        = genus; one of:
+; genus         = genus; one of:
 ;                 "GreatWonder", "SmallWonder", "Improvement", "Special",
 ;                 or "Convert".
-; reqs		= requirements to build the building (see effects.ruleset
-;		  and README.effects for help on requirements)
+; reqs          = requirements to build the building (see effects.ruleset
+;                 and README.effects for help on requirements)
 ; graphic       = icon of improvement (used in city dialog)
 ; graphic_alt   = alternate icon of improvement
 ; graphic_alt2  = second alternative icon.
-; obsolete_by	= requirements for the building to become obsolete
-; build_cost	= production shields required to build
-; upkeep	= monetary upkeep value
-; sabotage	= percent chance of diplomat sabotage being successful
+; obsolete_by   = requirements for the building to become obsolete
+; build_cost    = production shields required to build
+; upkeep        = monetary upkeep value
+; sabotage      = percent chance of diplomat sabotage being successful
 ; sound         = tag of the sound to play when building finished
 ; sound_alt     = alternate sound tag
 ; sound_alt2    = second alternative sound tag
@@ -73,9 +73,9 @@ format_version = 50
 ; */ <-- avoid gettext warnings
 
 [building_generic]
-name		= _("Generic")
-genus		= "Improvement"
-reqs	=
+name            = _("Generic")
+genus           = "Improvement"
+reqs    =
     { "type", "name", "range"
 ; No requirements
     }
@@ -85,12 +85,12 @@ graphic_alt2    = "-"
 obsolete_by     =
     { "type", "name", "range"
     }
-build_cost	= 100
-upkeep		= 0
-sabotage	= 100
-sound		= "b_generic"
-sound_alt	= "b_barracks"
+build_cost      = 100
+upkeep          = 0
+sabotage        = 100
+sound           = "b_generic"
+sound_alt       = "b_barracks"
 sound_alt2      = "-"
-helptext	= _("\
+helptext        = _("\
 This is the only building you can build.\
 ")
diff --git a/data/stub/effects.ruleset b/data/stub/effects.ruleset
index 3797fed978..54dfeaa47a 100644
--- a/data/stub/effects.ruleset
+++ b/data/stub/effects.ruleset
@@ -45,8 +45,8 @@ type    = "City_Vision_Radius_Sq"
 value   = 5
 
 [effect_base_unit_upkeep]
-type	= "Upkeep_Pct"
-value	= 100
+type    = "Upkeep_Pct"
+value   = 100
 
 [effect_empire_size_base]
 type    = "Empire_Size_Base"
diff --git a/data/stub/game.ruleset b/data/stub/game.ruleset
index 68446b52bd..e3b1fc3836 100644
--- a/data/stub/game.ruleset
+++ b/data/stub/game.ruleset
@@ -80,19 +80,19 @@ food_cost        = 2
 ;   if city_size > num_inis;
 ;     city_granary_size = (granary_food_ini[num_inis] +
 ;        granary_food_inc * (city_size - num_inis)) * foodbox / 100
-granary_food_ini	= 20
-granary_food_inc	= 10
+granary_food_ini        = 20
+granary_food_inc        = 10
 
 ; City center minimum outputs
-min_city_center_food	= 1
-min_city_center_shield	= 1
-min_city_center_trade	= 0
+min_city_center_food    = 1
+min_city_center_shield  = 1
+min_city_center_trade   = 0
 
 ; Square of initial city radius
 init_city_radius_sq     = 5
 
 ; Square of initially visible radius (true distance).
-init_vis_radius_sq	= 5
+init_vis_radius_sq      = 5
 
 ; A base bribe cost, modified heavily by other factors
 base_bribe_cost  = 750
diff --git a/data/stub/nations.ruleset b/data/stub/nations.ruleset
index 99285d0f2d..06184255d0 100644
--- a/data/stub/nations.ruleset
+++ b/data/stub/nations.ruleset
@@ -57,7 +57,7 @@ format_version = 50
 ; The first set defined is the one that is used by default. It is mandatory
 ; to have at least one, but if there is only one, it will be kept out of
 ; the user`s way.
-; name 		= Translatable name of the set presented in the UI.
+; name          = Translatable name of the set presented in the UI.
 ; rule_name     = Unique persistent name; this is also visible to users as
 ;                 the value of the "nationset" server option, and presented
 ;                 in "/list nationsets". It should thus be short, in lower
@@ -78,11 +78,11 @@ rule_name = "all"
 ; These are more cosmetic than sets; they affect the "pick nation" dialog,
 ; random nation selection, and possibly ruleset behavior.
 ; It`s OK to not define any nation groups at all.
-; name 		= name of the group (used adjectivally)
+; name          = name of the group (used adjectivally)
 ; hidden        = TRUE to not include this group in the "pick nation" dialog
 ;                 (for instance if it's for use in a NationGroup requirement).
 ;                 Default FALSE.
-; match		= How much the AI will try to select a nation in the same
+; match         = How much the AI will try to select a nation in the same
 ;                 group
 
 [ngroup_generic]
-- 
2.47.2